#!/usr/bin/env python3
# -*- coding: utf-8 -*-

########################################################################
## /**
##  * [Sample code to create and post Measurement]
##  * @param {String} <<CSV_ROW[0]>> temperature
##  * @param {String} <<CSV_ROW[1]>> time
##  * @return HTTP status code
## */
########################################################################

### import library
import csv
import json
from datetime import datetime
import requests # pip3 install --user requests

### YOUR OWN ACCOUNT INFORMATION
USER = "USER_NAME"
PASSWORD = "PASSWORD"
TENANT_NAME = "TENANT_NAME"
GLOBAL_ID = "DEVICE_GLOBAL_ID"
DOMAIN = "https://" + TENANT_NAME + ".je1.thingscloud.ntt.com"

ENDPOINT = "measurement/measurements"
URL = DOMAIN + "/" + ENDPOINT
FILE_NAME = "data.csv"

### Measurement format
measurement = {
    "c8y_TemperatureMeasurement": {
        "T": {
            "value": 0,
            "unit": "C"
        }
    },
    "time": "",
    "source": {
    	"id": GLOBAL_ID
    },
    "type": "c8y_TemperatureMeasurement"
}
### Object for Measurement Collection
measurements = {
    "measurements": []
}

### Header for Measurement
headers_1 = {
    "content-type": "application/json",
    "accept": "application/vnd.com.nsn.cumulocity.measurement+json"
}
### Header for Measurement Collection
headers_2 = {
    "content-type": "application/json",
    "accept": "application/vnd.com.nsn.cumulocity.measurementCollection+json"
}

### Read CSV
with open(FILE_NAME, "r") as f:
    reader = csv.reader(f)
    header = next(reader)
    print("Measurement")
    for row in reader:
        measurement["c8y_TemperatureMeasurement"]["T"]["value"] = int(row[0])
        # set time_value to time in CSV
        measurement["time"] = row[1]
        # # set time_value to current time
        # measurement["time"] = datetime.utcnow().isoformat()

        ##################################################
        # POST Measurement (Sequential transmission)
        ##################################################
        r = requests.post(URL, auth=(USER, PASSWORD), headers=headers_1, data=json.dumps(measurement))
        print("status : " + str(r.status_code))
        measurements["measurements"].append(measurement)

##################################################
# POST Measurement Collection (Bulk transmission)
##################################################
r = requests.post(URL, auth=(USER, PASSWORD), headers=headers_2, data=json.dumps(measurements))
print("Measurement Collection")
print("status : " + str(r.status_code))
